library ac_dart.descriptor_model.confluence.locations;

import 'package:atlassian_connect_models/src/descriptor/descriptor_model.dart';

final _ConfluenceLocations confluence = new _ConfluenceLocations._();

const String _locationPrefix = 'org.confluence.';

class _ConfluenceLocations {
  final _RepoLocations repository = new _RepoLocations._();
  final _AccountLocations account = new _AccountLocations._();

  _ConfluenceLocations._();
}

class ConfluenceLocation extends ModuleLocation {
  ConfluenceLocation._(String key) : super(key);
}

class _RepoLocations {
  final ConfluenceLocation actions = _create('actions');
  final ConfluenceLocation admin = _create('admin');
  final ConfluenceLocation navigation = _create('navigation');
  final ConfluenceLocation informationPanel =
      _create('overview.informationPanel');

  _RepoLocations._();

  static ConfluenceLocation _create(String suffix) =>
      new ConfluenceLocation._(_locationPrefix + 'repository.' + suffix);
}

class _AccountLocations {
  final ConfluenceLocation admin = _create('admin');

  _AccountLocations._();

  static ConfluenceLocation _create(String suffix) =>
      new ConfluenceLocation._(_locationPrefix + 'account.' + suffix);
}
