library ac_dart.descriptor_model.jira.locations;

import 'package:atlassian_connect_models/src/descriptor/descriptor_model.dart';

final _JiraLocations jira = new _JiraLocations._();

const String _locationPrefix = 'org.jira.';

class _JiraLocations {
  final _RepoLocations repository = new _RepoLocations._();
  final _AccountLocations account = new _AccountLocations._();

  _JiraLocations._();
}

class JiraLocation extends ModuleLocation {
  JiraLocation._(String key) : super(key);
}

class _RepoLocations {
  final JiraLocation actions = _create('actions');
  final JiraLocation admin = _create('admin');
  final JiraLocation navigation = _create('navigation');
  final JiraLocation informationPanel = _create('overview.informationPanel');

  _RepoLocations._();

  static JiraLocation _create(String suffix) =>
      new JiraLocation._(_locationPrefix + 'repository.' + suffix);
}

class _AccountLocations {
  final JiraLocation admin = _create('admin');

  _AccountLocations._();

  static JiraLocation _create(String suffix) =>
      new JiraLocation._(_locationPrefix + 'account.' + suffix);
}
